/* 
   Affix - Bluetooth Protocol Stack for Linux
   Copyright (C) 2001,2002 Nokia Corporation
   Author: Dmitry Kasatkin <dmitry.kasatkin@nokia.com>

   Original Author: Guruprasad Krishnamurthy <kgprasad@hotmail.com>

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*
   $Id: attr.h,v 1.10 2002/10/29 14:33:40 kds Exp $

   Fixes:
   		Dmitry Kasatkin		: cleanup, fixes
*/
	 
#ifndef SDP_DYN_ATTR_H
#define SDP_DYN_ATTR_H

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#include <affix/sdp.h>

#define SDP_PDU_CHUNK_SIZE 1024

void setSequenceLengthPDU(PDUForm *pduForm);
int appendToPduForm(PDUForm *dst, PDUForm *src);

void generateServiceRecordPduFormById(ServiceRecord *svcRec, 
			ServiceAttributeIdentifier attrId,PDUForm *attrSubsetPduForm);       

int generatePDUForm(PDUForm *pduForm, SDPData *pData);
         
void setSequenceLength(char *ptr, int length);

void removeSDPAttribute(ServiceRecord *svcRec, ServiceAttributeIdentifier attrId);

void generateServiceRecordPduForm(ServiceRecord *svcRec);

void attrPduForm(void * value, void * data);

int addToAttributeList(ServiceRecord *svcRec, ServiceAttributeIdentifier attrId,
			SDPData *pSDPData, int replaceFlag);

void addUUIDToTargetPattern(ServiceRecord *svcRec, UUID *pUUID);

static inline void addUUID16ToTargetPattern(ServiceRecord *svcRec, UUID16Bit uuid16)
{
	UUID	uuid;
	makeUUIDFrom16Bits(&uuid, uuid16);
	addUUIDToTargetPattern(svcRec, &uuid);
}

int extractUUID(char *buffer, UUID *pUUID, int *bytesScanned);

UUID *convertTo128Bits(UUID *pUUID);


#endif // SDP_DYN_ATTR_H
